// Hello WorldDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Hello World.h"
#include "Hello WorldDlg.h"
//#include <string.h>
//#include <atlconv.h>  // for ATL string conversion macros
#include "DebenuPDFLibrary1011.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CHelloWorldDlg dialog




CHelloWorldDlg::CHelloWorldDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHelloWorldDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CHelloWorldDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CHelloWorldDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_HELLO_WORLD, &CHelloWorldDlg::OnBnClickedHelloWorld)
END_MESSAGE_MAP()


// CHelloWorldDlg message handlers

BOOL CHelloWorldDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CHelloWorldDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CHelloWorldDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CHelloWorldDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CHelloWorldDlg::OnBnClickedHelloWorld()
{
    // Create simple hellow world sample
    /*
     Quick PDF Library
     Sample #1: Hello world

    * Remember to set your license key below
    * This sample shows how to unlock the library, draw some
      simple text onto the page and save the PDF
    * A file called 1.hello-world.pdf is written to disk
    */

    // Declare and load Quick PDF Library DLL
    DebenuPDFLibraryDLL1011 QP("DebenuPDFLibraryDLL1011.dll");

    // Library key

    CStringW strLicenseKey = L"INSERT_LICENSE_KEY_HERE";

    // PDF output filename
    CStringW strFileName = L"hello-world.pdf";

    // Display message containing the library version
    CStringW strMessage = L"Quick PDF Library Hello World sample";
    strMessage += L"\n";
    strMessage += L"Library version: " + QP.LibraryVersion();

    // Unlock the library
    int iResult = QP.UnlockKey(strLicenseKey);
    if (iResult == 1)
    {
        strMessage = L"\n";
        strMessage = L"Valid license key: " + QP.LibraryVersion();

        // Set the origin for drawing co-ordinates to top left of page
        QP.SetOrigin(1);

        // Draw the 'Hello World' text on the PDF page
        QP.DrawText(100, 200, L"Hello world from C++ and the DLL Edition of Quick PDF Library");

        // Draw a circle
        QP.DrawCircle(250, 350, 100, 0);

        // Add an image
        QP.AddImageFromFile(L"quick_pdf_library.jpg", 0);

        // Get the width and height of the image
        int lWidth = QP.ImageWidth();
        int lHeight = QP.ImageHeight();

        // Draw the image onto the page using the the images
        // height and width.

        QP.DrawImage(350, 250, lWidth, lHeight);

        // Attempt to save the file
        if (QP.SaveToFile(strFileName) == 1)
        {
            // Display message that the 'Hello Word' file has been written successfully
            strMessage += L"\n";
            strMessage += L"\nFile " + strFileName + L" written successfully";

            AfxMessageBox(CStringA(strMessage), MB_ICONSTOP);
        }
        else
        {
            // Display cannot write to file message
            strMessage += L"\n";
            strMessage += L"Error, file could not be written";

            AfxMessageBox(CStringA(strMessage), MB_ICONSTOP);
        }
    }
    else
    {
        // Display invalid license key message
        strMessage += L"\n";
        strMessage += L"- Invalid license key -";
        strMessage += L"\n";
        strMessage += L"Please set your license key by editing this file";

        AfxMessageBox(CStringA(strMessage), MB_ICONSTOP);
    }
}